SystemOrganization addCategory: #'Seaside-Tests-WebServices'!

WAXmlComponent subclass: #WACalledXmlComponent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Tests-WebServices'!

!WACalledXmlComponent methodsFor: 'rendering' stamp: 'pmm 12/28/2010 17:23'!
renderContentOn: xml
	xml tag: 'called' with: [
		| callback |
		xml tag: 'name' with: 'answer'.
		xml tag: 'url' with: xml actionUrl.
		callback := xml callbacks store: (WAValueCallback on: [ :value |
			self answer: value ]).
		(xml tag: 'parameter')
			attributeAt: 'name' put: callback;
			attributeAt: 'hasValue' put: 'true';
			attributeAt: 'description' put: 'value to be answered' ]! !

WAXmlComponent subclass: #WASampleXmlComponent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Tests-WebServices'!

!WASampleXmlComponent class methodsFor: 'testing' stamp: 'pmm 12/28/2010 16:31'!
canBeRoot
	^ true! !

!WASampleXmlComponent class methodsFor: 'registering' stamp: 'pmm 12/28/2010 16:50'!
register
	WAXmlAdmin 
		register: self
		asApplicationAt: 'xml'! !

!WASampleXmlComponent methodsFor: 'actions' stamp: 'pmm 12/28/2010 17:20'!
action
	| value |
	value := self call: WACalledXmlComponent new.
	Transcript cr; show: value; cr! !

!WASampleXmlComponent methodsFor: 'rendering' stamp: 'pmm 12/28/2010 17:20'!
renderContentOn: xml
	xml tag: 'response' with: [
		xml tag: 'operation1' with: [
			| callback |
			xml tag: 'name' with: 'transcript'.
			xml tag: 'url' with: xml actionUrl.
			callback := xml callbacks store: (WAValueCallback on: [ :value |
				Transcript cr; show: value; cr ]).
			(xml tag: 'parameter')
				attributeAt: 'name' put: callback;
				attributeAt: 'hasValue' put: 'true';
				attributeAt: 'description' put: 'shown in Transcript' ].
		xml tag: 'operation2' with: [
			| callback |
			xml tag: 'name' with: 'call'.
			xml tag: 'url' with: xml actionUrl.
			callback := xml callbacks store: (WAActionCallback on: [
				self action ]).
			(xml tag: 'parameter')
				attributeAt: 'name' put: callback;
				attributeAt: 'hasValue' put: 'false' ] ] ! !
